/*	Dio.java
 *
 *	Digital Input DEMO for i7k series module
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
  
import com.icpdas.cardio.ixpio.*;							//For System.in.read()
import com.icpdas.comm.*;								//ICPDAS communication packages

public class Dio 
{
	public static void main(String[] args)
	{
		int rev;
		int fd;
		Comm comm1 = new Comm();						//ICPDAS communication object
		IoBuf i7kBuf = new IoBuf();						//control matrix	
		rev = comm1.open(1,115200,comm1.DATABITS_8,comm1.PARITY_NONE,comm1.STOPBITS_1);//open serial port
		if (rev!=0) System.out.println("Open port error code : "+rev);
		else{		
			i7kBuf.dwBuf[0] =1;							//Serial Port no
			i7kBuf.dwBuf[1] =1;							//Address
			i7kBuf.dwBuf[2] =0x7060;						//0x7060; //module name
			i7kBuf.dwBuf[3] =0;							//check sum disable
			i7kBuf.dwBuf[4] =10;							//Timeout 100ms
			rev = comm1.getDigitalIn(i7kBuf);					//Get Digital Input Value from 7060
			if (rev!=0) System.out.println("Digital In Error Code : "+ rev);
			else System.out.println("Digital In : "+ i7kBuf.dwBuf[5]);		
		}
		comm1.close(1);
		System.out.println(rev);
		System.out.println("End of program");		
	}
}
