#!/bin/sh

# check that we're root
if [ $(whoami) != "root" ]
then
	echo "You must run this script as root. Try running 'su -'"
	exit 1
fi

if [ -z "${JAVA_HOME}" ]
then
	echo "Your JAVA_HOME environment variable must be set"
	exit 1
fi

	echo "Installing SDK for JAVA lib Build to JAVA_HOME=${JAVA_HOME}"

	cp libdconjni.so /usr/lib
	if [ "$?" -ne 0 ]; then echo "Copy failed"; exit 1; fi

	cp icpdas.jar $JAVA_HOME/lib/
	if [ "$?" -ne 0 ]; then echo "Copy failed"; exit 1; fi

SYSINIT=`cat /etc/rc.sysinit | grep .viminfo`
PATH=`cat /etc/profile | grep icpdas.jar`

if [ -z "$PATH" ];
then
	echo export CLASSPATH=${JAVA_HOME}/lib/:${JAVA_HOME}/lib/tools.jar:${JAVA_HOME}/lib/dt.jar:${JAVA_HOME}/lib/icpdas.jar:. >> /etc/profile
	echo export LD_LIBRARY_PATH=/usr/lib:/usr/local/lib: >> /etc/profile
fi

if [ -z "$SYSINIT" ];
then
	echo rm -f /root/.viminfo >> /etc/rc.sysinit
fi
	echo "JAVA lib Build Installed"

